unit U_YSCRPB_GZ;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, cxGraphics, cxCustomData, cxStyles, cxTL, cxMaskEdit, DB, ADODB,
  cxInplaceContainer, cxDBTL, cxControls, cxTLData, ComCtrls, ToolWin,
  StdCtrls, cxFilter, cxData, cxDataStorage, cxEdit, cxDBData, DBClient,
  cxGridCustomTableView, cxGridTableView, cxGridDBTableView, ExtCtrls,
  cxSplitter, cxGridLevel, cxClasses, cxGridCustomView, cxGrid,
  cxGridCustomPopupMenu, cxGridPopupMenu, RM_Dataset, RM_System, RM_Common,
  RM_Class, RM_GridReport, IdBaseComponent, IdComponent, IdTCPConnection,
  IdTCPClient, IdFTP,ShellAPI,IniFiles, cxCheckBox, cxCalendar,
  cxButtonEdit, cxTextEdit, cxPC, cxDropDownEdit;

type
  TfrmYSCRPB_GZ = class(TForm)
    ToolBar1: TToolBar;
    TBRafresh: TToolButton;
    TBDel: TToolButton;
    TBClose: TToolButton;
    ADOQueryTemp: TADOQuery;
    ADOQueryCmd: TADOQuery;
    Panel1: TPanel;
    ToolButton2: TToolButton;
    Label1: TLabel;
    YFName: TEdit;
    ADOQueryMain: TADOQuery;
    ToolButton1: TToolButton;
    RM1: TRMGridReport;
    RMDB_Main: TRMDBDataSet;
    cxGrid2: TcxGrid;
    Tv2: TcxGridDBTableView;
    cxGridDBColumn1: TcxGridDBColumn;
    cxGridDBColumn3: TcxGridDBColumn;
    cxGridLevel1: TcxGridLevel;
    Label2: TLabel;
    Label6: TLabel;
    begdate: TDateTimePicker;
    Enddate: TDateTimePicker;
    cxGridPopupMenu2: TcxGridPopupMenu;
    DS_HZ: TDataSource;
    CDS_HZ: TClientDataSet;
    ToolButton3: TToolButton;
    VMoney: TcxGridDBColumn;
    v2Column6: TcxGridDBColumn;
    v2Column2: TcxGridDBColumn;
    v2Column5: TcxGridDBColumn;
    Label7: TLabel;
    Edit1: TEdit;
    Button1: TButton;
    CheckBox1: TCheckBox;
    GangWei: TEdit;
    Label8: TLabel;
    Tchk: TToolButton;
    Tnochk: TToolButton;
    cxTabControl1: TcxTabControl;
    v2Dept: TcxGridDBColumn;
    TZDSC: TToolButton;
    Label11: TLabel;
    Label13: TLabel;
    Label4: TLabel;
    Dept: TEdit;
    Label5: TLabel;
    Note: TEdit;
    ADOQuery1: TADOQuery;
    Label3: TLabel;
    GZName: TEdit;
    Label9: TLabel;
    FactoryName: TEdit;
    v2GZMonth: TcxGridDBColumn;
    v2GZName: TcxGridDBColumn;
    v2GangWei: TcxGridDBColumn;
    v2GWMoney: TcxGridDBColumn;
    v2JXMoney: TcxGridDBColumn;
    v2BTMoney: TcxGridDBColumn;
    v2JBMoney: TcxGridDBColumn;
    v2KouKuan: TcxGridDBColumn;
    v2filltme: TcxGridDBColumn;
    v2ZGDay: TcxGridDBColumn;
    Label10: TLabel;
    GZMonth: TEdit;
    v2ComTaiTou: TcxGridDBColumn;
    Label12: TLabel;
    ComTaiTou: TEdit;
    TPrint: TToolButton;
    Order_Print: TClientDataSet;
    procedure FormDestroy(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure TBCloseClick(Sender: TObject);
    procedure TBDelClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure TBRafreshClick(Sender: TObject);
    procedure ToolButton2Click(Sender: TObject);
    procedure GZNameChange(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure cxGridDBColumn8PropertiesEditValueChanged(Sender: TObject);
    procedure cxGridDBColumn5PropertiesEditValueChanged(Sender: TObject);
    procedure cxGridDBColumn1PropertiesEditValueChanged(Sender: TObject);
    procedure ToolButton3Click(Sender: TObject);
    procedure cxGridDBColumn3PropertiesButtonClick(Sender: TObject;
      AButtonIndex: Integer);
    procedure cxGridDBColumn6PropertiesButtonClick(Sender: TObject;
      AButtonIndex: Integer);
    procedure v2Column3PropertiesButtonClick(Sender: TObject;
      AButtonIndex: Integer);
    procedure ToolButton1Click(Sender: TObject);
    procedure v2Column7PropertiesButtonClick(Sender: TObject;
      AButtonIndex: Integer);
    procedure v2PSPropertiesEditValueChanged(Sender: TObject);
    procedure v2Column2PropertiesEditValueChanged(Sender: TObject);
    procedure v2KPMoneyPropertiesEditValueChanged(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    procedure cxTabControl1Change(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure TchkClick(Sender: TObject);
    procedure TnochkClick(Sender: TObject);
    procedure v2ComTaitouPropertiesButtonClick(Sender: TObject;
      AButtonIndex: Integer);
    procedure TZDSCClick(Sender: TObject);
    procedure VBZPropertiesButtonClick(Sender: TObject;
      AButtonIndex: Integer);
    procedure v2Column4PropertiesButtonClick(Sender: TObject;
      AButtonIndex: Integer);
    procedure v2Column5PropertiesChange(Sender: TObject);
    procedure v2ConNoHZPropertiesButtonClick(Sender: TObject;
      AButtonIndex: Integer);
    procedure v2GYSNamePropertiesButtonClick(Sender: TObject;
      AButtonIndex: Integer);
    procedure v2Column6PropertiesButtonClick(Sender: TObject;
      AButtonIndex: Integer);
    procedure DeptKeyPress(Sender: TObject; var Key: Char);
    procedure GangWeiKeyPress(Sender: TObject; var Key: Char);
    procedure v2GWMoneyPropertiesEditValueChanged(Sender: TObject);
    procedure v2GZNamePropertiesButtonClick(Sender: TObject;
      AButtonIndex: Integer);
    procedure v2GangWeiPropertiesButtonClick(Sender: TObject;
      AButtonIndex: Integer);
    procedure v2DeptPropertiesButtonClick(Sender: TObject;
      AButtonIndex: Integer);
    procedure TPrintClick(Sender: TObject);
  private
    { Private declarations }

    procedure InitGridHZ();
    procedure InitGrid();
    function  SaveData():Boolean;
    procedure SetStatus();

  public

    fflag:integer;
    { Public declarations }
    RKFlag,FCYID,canshu1,canshu2,canshu3:String;
    fmanage:string;

  end;

var
  frmYSCRPB_GZ: TfrmYSCRPB_GZ;

implementation
uses
  U_DataLink,U_Fun,U_ZDYHelp, U_ProductOrderNewList, U_ProductOrderList,
  U_ZdyAttachment, U_SXCKNewList, U_SXCKNewList_SK,U_JYOrderCon_CX,
  U_ZdyAttachGYS,U_FKCR;

{$R *.dfm}
procedure TfrmYSCRPB_GZ.SetStatus();
var i:integer;
begin
  Tchk.Enabled:=false;
  TNochk.Enabled:=false;
  for i:=0 to tv2.ColumnCount-1 do
  begin
    IF uppercase(tv2.Columns[i].DataBinding.FieldName)<>'SSEL' then
    tv2.Columns[i].Options.Editing:=false;
  end;
    if cxTabControl1.TabIndex=0 then
    begin
      Tchk.Enabled:=true;
      for i:=0 to tv2.ColumnCount-1 do
      begin
        tv2.Columns[i].Options.Editing:=true;
      end;
    end;
    if cxTabControl1.TabIndex=1 then
    begin
      TNochk.Enabled:=true;
    end;
    if cxTabControl1.TabIndex=2 then
    begin
    end;
end;

procedure TfrmYSCRPB_GZ.InitGrid();
begin
  try
    ADOQueryMain.DisableControls;
    with ADOQueryMain do
    begin
      Filtered:=False;
      Close;
      SQL.Clear;
      sql.Add('select SCOrderNO=(select Top 1 JM.ConNo from Cloth_Main JM where JM.Mainid=A.Mainid),');
      sql.add('RMBMoney=(case when (A.BZType<>''$'') and (A.BZType<>''USD'') then Money else 0 end)');
      sql.add(',USDMoney=(case when (A.BZType<>''￥'') and (A.BZType<>''RMB'') then Money else 0 end)');
      sql.add(',isnull((select JM.PRTColor from JYOrder_Sub JM inner join CK_SXPB_CR F on JM.Subid=F.ORDSubIdRK where F.SPID=A.YFTypeId),'''') PRTColor,');
      sql.add('A.*');
      sql.Add(' from YF_Money_CR A');
      sql.Add(' where A.CRType=''应付款登记''  ');         //and A.YFDefFlag1='''+inttostr(fflag)+'''
      sql.add(' and isnull(FeeType,'''')=''虚拟费用''');
      sql.add(' and A.CRTime>='''+FormatDateTime('yyyy-MM-dd',begdate.DateTime)+''' ');
      sql.Add(' and A.CRTime<'''+FormatDateTime('yyyy-MM-dd',Enddate.DateTime+1)+''' ');
      sql.add(' and A.YFName=''工资''');
      Open;
    end;
    SCreateCDS20(ADOQueryMain,CDS_HZ);
    SInitCDSData20(ADOQueryMain,CDS_HZ);
    Label13.Caption:='0';
  finally
    ADOQueryMain.EnableControls;
    //ToolButton2.Click;
  end;
end;

procedure TfrmYSCRPB_GZ.InitGridHZ();
begin

end;

procedure TfrmYSCRPB_GZ.FormDestroy(Sender: TObject);
begin
  frmYSCRPB_GZ:=nil;
end;

procedure TfrmYSCRPB_GZ.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Action:=caFree;
end;

procedure TfrmYSCRPB_GZ.TBCloseClick(Sender: TObject);
begin
  WriteCxGrid('应收款登记4',Tv2,'财务管理');
  {with ADOQueryCmd do
  begin
    Close;
    SQL.Clear;
    sql.Add('delete CK_YP_CR where isnull(CRTime,'''')='''' and CYID='''+Trim(FCYID)+''' and CRType='''+Trim(RKFlag)+'''');
    ExecSQL;
  end;}
  Close;
end;
procedure TfrmYSCRPB_GZ.TBDelClick(Sender: TObject);
var
  FBBMoney,CRID:string;
begin
  if CDS_HZ.IsEmpty then Exit;
  //if cxtabcontrol1.TabIndex<>0 then exit;
  

  if CDS_HZ.Locate('ssel',true,[])=false then
  begin
    Application.MessageBox('没有选择数据!','提示',0);
    Exit;
  end;

  if Application.MessageBox('确定要删除数据吗？','提示',32+4)<>IDYES then Exit;
  try
    ADOQueryCmd.Connection.BeginTrans;
    with CDS_HZ do
    begin
      DisableControls;
      First;
      while not eof do
      begin
        IF Fieldbyname('ssel').AsBoolean=true then
        begin
          with ADOQueryCmd do
          begin
            close;
            sql.Clear;
            sql.Add('delete YF_Money_CR where YFID='''+Trim(CDS_HZ.fieldbyname('YFID').AsString)+'''');
            execsql;
          end;
        end;
        next;
      end;
      First;
      EnableControls;
    end;
    InitGrid();
    ADOQueryCmd.Connection.CommitTrans;
  except
    ADOQueryCmd.Connection.RollbackTrans;
    application.MessageBox('操作失败！','提示信息',0);
  end;
end;

procedure TfrmYSCRPB_GZ.FormShow(Sender: TObject);
begin
  ReadCxGrid('应收款登记4',Tv2,'财务管理');
  Enddate.DateTime:=SGetServerDate(ADOQueryTemp);
  begdate.DateTime:=SGetServerDate(ADOQueryTemp)-7;
  TZDSC.Visible:=false;
  if canshu2='杂费' then
  begin
    TZDSC.Visible:=true;
  end;
  {if Trim(DParameters2)='人民币' then
  begin
    VHL.Hidden:=True;
    VHL.Visible:=False;
    VBZ.Hidden:=True;
    VBZ.Visible:=False;
    VYB.Hidden:=True;
    VYB.Visible:=False;
    VBB.Caption:='金额';
  end;}
  
  //SetStatus();
  InitGrid();
end;

procedure TfrmYSCRPB_GZ.TBRafreshClick(Sender: TObject);
begin
  begdate.SetFocus;
  InitGrid();
end;

procedure TfrmYSCRPB_GZ.ToolButton2Click(Sender: TObject);
begin
  label13.Caption:='0';
  if ADOQueryMain.Active then
  begin
    SDofilter(ADOQueryMain,SGetFilters(Panel1,1,2));
    SCreateCDS20(ADOQueryMain,CDS_HZ);
    SInitCDSData20(ADOQueryMain,CDS_HZ);
  end;
end;

procedure TfrmYSCRPB_GZ.GZNameChange(Sender: TObject);
begin
  ToolButton2.Click;
end;

procedure TfrmYSCRPB_GZ.Button2Click(Sender: TObject);
begin
  if CDS_HZ.IsEmpty then Exit;
  if Application.MessageBox('确定要删除数据吗？','提示',32+4)<>IDYES then Exit;
  if Trim(CDS_HZ.fieldbyname('SubID').AsString)<>'' then
  begin
    with ADOQueryCmd do
    begin
      Close;
      SQL.Clear;
      sql.Add('delete YCL_SG_HZ where SubID='''+Trim(CDS_HZ.fieldbyname('SubID').AsString)+'''');
      ExecSQL;
    end;
  end;
  CDS_HZ.Delete;
end;

function TfrmYSCRPB_GZ.SaveData():Boolean;
var
  maxId,CRID:String;
begin
  try
    ADOQueryCmd.Connection.BeginTrans;
    if GetLSNo(ADOQueryCmd,maxId,'YC','YF_Money_CR',4,1)=False then
    begin
      Result:=False;
      ADOQueryCmd.Connection.RollbackTrans;
      Application.MessageBox('取最大号失败！','提示',0);
      Exit;
    end;
    with ADOQueryCmd do
    begin
      Close;
      SQL.Clear;
      sql.Add('select * from YF_Money_KC where FactoryName='''+Trim(CDS_HZ.fieldbyname('FactoryName').AsString)+'''');
      Open;
    end;
    if ADOQueryCmd.IsEmpty=False then
    begin
      CRID:=ADOQueryCmd.fieldbyname('CRID').AsString;
    end else
    begin
      with ADOQueryCmd do
      begin
        Close;
        sql.Clear;
        sql.Add('Update YF_Money_CRID set CRID=CRID+1');
        sql.Add('select * from YF_Money_CRID ');
        Open;
      end;
      CRID:=ADOQueryCmd.fieldbyname('CRID').AsString;
      with ADOQueryCmd do
      begin
        Close;
        SQL.Clear;
        sql.Add('select * from YF_Money_KC where 1<>1');
        Open;
      end;
      with ADOQueryCmd do
      begin
        Append;
        FieldByName('CRID').Value:=StrToInt(CRID);
        FieldByName('FactoryNo').Value:=Trim(CDS_HZ.fieldbyname('FactoryNo').AsString);
        FieldByName('FactoryName').Value:=Trim(CDS_HZ.fieldbyname('FactoryName').AsString);
        FieldByName('ZdyStr1').Value:='应付付';
    //    FieldByName('YFDefFlag1').Value:=fFlag;
        Post;
      end;
    end;
    with ADOQueryCmd do
    begin
      Close;
      SQL.Clear;
      sql.Add('select * from YF_Money_CR where 1=2');
      Open;
    end;
    with ADOQueryCmd do
    begin
      Append;
      FieldByName('YFID').Value:=Trim(maxId);
      FieldByName('CRID').Value:=StrToInt(CRID);
      //SSetSaveDataCDSNew(ADOQueryCmd,Tv2,CDS_HZ,'YF_Money_CR',3);
      FieldByName('Filler').Value:=Trim(DName);
      FieldByName('CRType').Value:='应付款登记';
      FieldByName('CRFlag').Value:='应付付';
      FieldByName('QtyFlag').Value:=1;
      FieldByName('FactoryName').Value:=Trim(CDS_HZ.fieldbyname('FactoryName').AsString);
      FieldByName('YFName').Value:=Trim(CDS_HZ.fieldbyname('YFName').AsString);
      FieldByName('FeeType').Value:=Trim(CDS_HZ.fieldbyname('FeeType').AsString);
      FieldByName('CRTime').Value:=CDS_HZ.fieldbyname('CRTime').AsDateTime;
      FieldByName('YFDefFlag1').Value:=fFlag;
      FieldByName('status').Value:='2';
      fieldbyname('HuiLv').Value:=CDS_HZ.fieldbyname('HuiLv').AsFloat;
      fieldbyname('Money').Value:=CDS_HZ.fieldbyname('Money').AsFloat;
      fieldbyname('SLV').Value:=1;
      fieldbyname('BZType').Value:='￥';
      fieldbyname('ComTaitou').Value:=Trim(CDS_HZ.fieldbyname('ComTaitou').AsString);;
      fieldbyname('filltime').AsDateTime:=now;
      Post;
    end;
    with CDS_HZ do
    begin
      Edit;
      FieldByName('YFId').Value:=Trim(maxId);
      FieldByName('CRID').Value:=StrToInt(CRID);
    end;
    ADOQueryCmd.Connection.CommitTrans;
    Result:=True;
  except
    Result:=True;
    ADOQueryCmd.Connection.RollbackTrans;
    Application.MessageBox('增行失败!','提示',0);
  end;
end;

procedure TfrmYSCRPB_GZ.cxGridDBColumn8PropertiesEditValueChanged(
  Sender: TObject);
var
  mvalue,FFieldName:String;
begin
  mvalue:=TcxTextEdit(Sender).EditingText;
  FFieldName:=Trim(Tv2.Controller.FocusedColumn.DataBinding.FilterFieldName);
  with CDS_HZ do
  begin
    Edit;
    FieldByName(FFieldName).Value:=Trim(mvalue);
    Post;
  end;
  with ADOQueryCmd do
  begin
    Close;
    sql.Clear;
    sql.Add('UPdate YCL_SG_HZ ');
    if Trim(mvalue)<>'' then
    begin
      sql.Add(' Set '+FFieldName+'='''+Trim(mvalue)+'''');
    end else
    begin
      sql.Add(' Set '+FFieldName+'=NULL');
    end;
    SQL.Add(',Editer='''+Trim(DName)+'''');
    SQL.Add(',Edittime=getdate() ');
    SQL.Add(' where SubId='''+Trim(CDS_HZ.fieldbyname('SubId').AsString)+'''');
    ExecSQL;
  end;
end;

procedure TfrmYSCRPB_GZ.cxGridDBColumn5PropertiesEditValueChanged(
  Sender: TObject);
var
  mvalue,FQty,FPrice,FMoney,FHuiLv,FBBMoney,FKCBB,FFieldName,FSLV:String;
begin
  {if Trim(CDS_HZ.fieldbyname('YFType').AsString)<>'' then
  begin
    Application.MessageBox('自动生成数据不能更改!','提示',0);
    Exit;
  end; }
  mvalue:=TcxTextEdit(Sender).EditingText;
  if Trim(mvalue)='' then
  begin
    mvalue:=NULL;
  end;
  FFieldName:=Trim(Tv2.Controller.FocusedColumn.DataBinding.FilterFieldName);
  with CDS_HZ do
  begin
    Edit;
    FieldByName(FFieldName).Value:=Trim(mvalue);
    if Trim(DParameters2)='人民币' then
    begin
      FieldByName('HuiLv').Value:=1;
    end;
    Post;
  end;
  with ADOQueryTemp do
  begin
    Close;
    sql.Clear;
    sql.Add('select isnull(BBMoney,0) BBMoney from YF_Money_CR where YFID='''+cds_hz.fieldbyname('YFID').AsString+'''');
    Open;
  end;
  FKCBB:=ADOQueryTemp.fieldbyname('BBMoney').AsString;

  FQty:=Trim(CDS_HZ.fieldbyname('Qty').AsString);
  if Trim(FQty)='' then FQty:='0';

  FPrice:=Trim(CDS_HZ.fieldbyname('Price').AsString);
  if Trim(FPrice)='' then FPrice:='0';
  FQty:=Trim(CDS_HZ.fieldbyname('Qty').AsString);
  if Trim(FQty)='' then FQty:='0';

  FMoney:=Trim(CDS_HZ.fieldbyname('Money').AsString);
  if Trim(FMoney)='' then FMoney:='0';

  FHuiLv:=Trim(CDS_HZ.fieldbyname('HuiLv').AsString);
  if Trim(FHuiLv)='' then FHuiLv:='1';

  FSLV:=Trim(CDS_HZ.fieldbyname('SLV').AsString);
  if Trim(FSLV)='' then FSLV:='0';

  {FBBMoney:=Trim(CDS_HZ.fieldbyname('BBMoney').AsString);
  if Trim(FBBMoney)='' then FBBMoney:='0'; }

  if Trim(FFieldName)<>'Money' then
  begin
    if Trim(FFieldName)<>'HuiLv' then
    begin
      FBBMoney:=FloatToStr(StrToFloat(FQty)*StrToFloat(FPrice)*StrToFloat(FHuiLv)*StrToFloat(FSLV));
      FMoney:=FloatToStr(StrToFloat(FQty)*StrToFloat(FPrice));
    end else
    begin
      FBBMoney:=FloatToStr(StrToFloat(FMoney)*StrToFloat(FHuiLv)*StrToFloat(FSLV));
    end;

  end else
  begin
    FBBMoney:=FloatToStr(StrToFloat(FMoney)*StrToFloat(FHuiLv)*StrToFloat(FSLV));
  end;
  with CDS_HZ do
  begin
    Edit;
    FieldByName('Money').Value:=StrToFloat(FMoney);
    FieldByName('BBMoney').Value:=StrToFloat(FBBMoney);
    Post;
  end;
  with ADOQueryCmd do
  begin
    Close;
    sql.Clear;
    sql.Add('UPdate YF_Money_CR ');
    sql.Add(' Set '+FFieldName+'='+Trim(mvalue));
    if Trim(FFieldName)<>'Money' then
    begin
      sql.Add(',Money='+FMoney);
    end;

    sql.Add(',BBMoney='+FBBMoney);
    SQL.Add(',Editer='''+Trim(DName)+'''');
    SQL.Add(',Edittime=getdate() ');
    SQL.Add(' where YFId='''+Trim(CDS_HZ.fieldbyname('YFId').AsString)+'''');
    
    SQL.Add('Update YF_Money_KC Set KCBBMoney=KCBBMoney-'+FKCBB+'+'+FBBMoney);
    sql.Add(' where CRID='''+Trim(CDS_HZ.fieldbyname('CRID').AsString)+'''');
    ExecSQL;
  end;
  tv2.Controller.EditingController.ShowEdit();
end;

procedure TfrmYSCRPB_GZ.cxGridDBColumn1PropertiesEditValueChanged(
  Sender: TObject);
var
  mvalue,FFieldName:String;
begin
  mvalue:=TcxTextEdit(Sender).EditingText;
  FFieldName:=Trim(Tv2.Controller.FocusedColumn.DataBinding.FilterFieldName);
  with CDS_HZ do
  begin
    Edit;
    FieldByName(FFieldName).Value:=Trim(mvalue);
    Post;
  end;
  with ADOQueryCmd do
  begin
    Close;
    sql.Clear;
    sql.Add('UPdate YF_Money_CR ');
    if Trim(mvalue)<>'' then
    begin
      sql.Add(' Set '+FFieldName+'='''+Trim(mvalue)+'''');
    end else
    begin
      sql.Add(' Set '+FFieldName+'=NULL');
    end;
    SQL.Add(',Editer='''+Trim(DName)+'''');
    SQL.Add(',Edittime=getdate() ');
    SQL.Add(' where YFId='''+Trim(CDS_HZ.fieldbyname('YFId').AsString)+'''');
    ExecSQL;
  end;
end;

procedure TfrmYSCRPB_GZ.ToolButton3Click(Sender: TObject);
begin
  try
    frmZdyHelp:=TfrmZdyHelp.Create(Application);
    with frmZdyHelp do
    begin
      flag:='GZFactoryName';
      flagName:='对方单位';
      if ShowModal=1 then
      begin
        with Self.CDS_HZ do
        begin
          Append;
          //FieldByName('FactoryNo').Value:=Trim(ClientDataSet1.fieldbyname('ZdyCode').AsString);
          FieldByName('FactoryName').Value:=Trim(ClientDataSet1.fieldbyname('ZdyName').AsString);
          FieldByName('CRTime').Value:=SGetServerDate(ADOQueryTemp);
          fieldbyname('filler').Value:=trim(DName);
          fieldbyname('HuiLv').Value:=1;
          fieldbyname('SLV').Value:=1;
          fieldbyname('BZType').Value:='￥';
          fieldbyname('FeeType').Value:='虚拟费用';
          fieldbyname('ComTaitou').Value:='今墨';
          fieldbyname('YFName').Value:='工资';
          fieldbyname('filltime').Value:=now;
          Post;
        end;
        Self.SaveData();
      end;
    end;
  finally
    frmZdyHelp.Free;
  end;
end;

procedure TfrmYSCRPB_GZ.cxGridDBColumn3PropertiesButtonClick(Sender: TObject;
  AButtonIndex: Integer);
begin
  if Trim(CDS_HZ.fieldbyname('YFType').AsString)<>'' then
  begin
    Application.MessageBox('自动生成数据不能更改!','提示',0);
    Exit;
  end;
  try
    frmZDYHelp:=TfrmZDYHelp.Create(Application);
    with frmZDYHelp do
    begin
      flag:='YFName';
      flagname:='费用名称';
      MainType:=trim(DName)+'工资';
      if ShowModal=1 then
      begin
        with Self.CDS_HZ do
        begin
          Edit;
          FieldByName('YFCode').Value:=Trim(ClientDataSet1.fieldbyname('ZdyNo').AsString);
          FieldByName('YFName').Value:=Trim(ClientDataSet1.fieldbyname('ZdyName').AsString);
        end;
        with ADOQueryCmd do
        begin
          Close;
          sql.Clear;
          sql.Add('UPdate YF_Money_CR ');
          sql.Add(' Set YFCode='''+Trim(ClientDataSet1.fieldbyname('ZdyNo').AsString)+'''');
          sql.Add(' ,YFName='''+Trim(ClientDataSet1.fieldbyname('ZdyName').AsString)+'''');
          SQL.Add(',Editer='''+Trim(DName)+'''');
          SQL.Add(',Edittime=getdate() ');
          SQL.Add(' where YFId='''+Trim(CDS_HZ.fieldbyname('YFId').AsString)+'''');
          ExecSQL;
        end;
      end;
    end;
  finally
    frmZDYHelp.Free;
  end;
end;

procedure TfrmYSCRPB_GZ.cxGridDBColumn6PropertiesButtonClick(Sender: TObject;
  AButtonIndex: Integer);
begin
  try
    frmZDYHelp:=TfrmZDYHelp.Create(Application);
    with frmZDYHelp do
    begin
      flag:='OrderUnit';
      flagname:='数量单位';
      if ShowModal=1 then
      begin
        Self.CDS_HZ.Edit;
        Self.CDS_HZ.FieldByName('QtyUnit').Value:=Trim(ClientDataSet1.fieldbyname('ZDYName').AsString);
        with ADOQueryCmd do
        begin
          Close;
          sql.Clear;
          sql.Add('UPdate YF_Money_CR ');
          sql.Add(' Set QtyUnit='''+Trim(ClientDataSet1.fieldbyname('ZdyName').AsString)+'''');
          SQL.Add(',Editer='''+Trim(DName)+'''');
          SQL.Add(',Edittime=getdate() ');
          SQL.Add(' where YFId='''+Trim(CDS_HZ.fieldbyname('YFId').AsString)+'''');
          ExecSQL;
        end;
      end;
    end;
  finally
    frmZDYHelp.Free;
  end;
end;

procedure TfrmYSCRPB_GZ.v2Column3PropertiesButtonClick(Sender: TObject;
  AButtonIndex: Integer);
begin
  try
    frmZDYHelp:=TfrmZDYHelp.Create(Application);
    with frmZDYHelp do
    begin
      flag:='MP_CodeName';
      flagname:='品名';
      if ShowModal=1 then
      begin
        Self.CDS_HZ.Edit;
        Self.CDS_HZ.FieldByName('P_CodeName').Value:=Trim(ClientDataSet1.fieldbyname('ZDYName').AsString);
        with ADOQueryCmd do
        begin
          Close;
          sql.Clear;
          sql.Add('UPdate YF_Money_CR ');
          sql.Add(' Set P_CodeName='''+Trim(ClientDataSet1.fieldbyname('ZdyName').AsString)+'''');
          SQL.Add(',Editer='''+Trim(DName)+'''');
          SQL.Add(',Edittime=getdate() ');
          SQL.Add(' where YFId='''+Trim(CDS_HZ.fieldbyname('YFId').AsString)+'''');
          ExecSQL;
        end;
      end;
    end;
  finally
    frmZDYHelp.Free;
  end;
end;

procedure TfrmYSCRPB_GZ.ToolButton1Click(Sender: TObject);
begin
  if ADOQueryMain.IsEmpty then Exit;
  SelExportData(Tv2,ADOQueryMain,'应收款列表');
end;

procedure TfrmYSCRPB_GZ.v2Column7PropertiesButtonClick(Sender: TObject;
  AButtonIndex: Integer);
begin
  try
    frmProductOrderNewList:=TfrmProductOrderNewList.Create(Application);
    with frmProductOrderNewList do
    begin
      //frmProductOrderList.v1Column4.Visible:=True;
      if ShowModal=1 then
      begin
        with Self.CDS_HZ do
        begin
          Edit;
          FieldByName('MainId').Value:=Trim(frmProductOrderNewList.Order_Main.fieldbyname('MainId').AsString);
          FieldByName('subID').Value:=Trim(frmProductOrderNewList.Order_Main.fieldbyname('subID').AsString);
          FieldByName('OrderNo').Value:=Trim(frmProductOrderNewList.Order_Main.fieldbyname('OrderNo').AsString);
          FieldByName('P_CodeName').Value:=Trim(frmProductOrderNewList.Order_Main.fieldbyname('MPRTCodeName').AsString);
          FieldByName('P_Spec').Value:=Trim(frmProductOrderNewList.Order_Main.fieldbyname('MPRTSpec').AsString);
          post;
          with ADOQueryCmd do
          begin
            Close;
            sql.Clear;
            sql.Add('UPdate YF_Money_CR ');
            sql.Add(' Set MainId='''+Trim(SELF.CDS_HZ.fieldbyname('MainId').AsString)+'''');
            sql.Add(' ,SubId='''+Trim(SELF.CDS_HZ.fieldbyname('SubId').AsString)+'''');
            sql.Add(' ,p_CodeName='''+Trim(SELF.CDS_HZ.fieldbyname('P_CodeName').AsString)+'''');
            sql.Add(' ,P_Spec='''+Trim(SELF.CDS_HZ.fieldbyname('P_Spec').AsString)+'''');
            sql.Add(' ,OrderNo='''+Trim(SELF.CDS_HZ.fieldbyname('OrderNo').AsString)+'''');
            SQL.Add(',Editer='''+Trim(DName)+'''');
            SQL.Add(',Edittime=getdate() ');
            SQL.Add(' where YFId='''+Trim(CDS_HZ.fieldbyname('YFId').AsString)+'''');
            ExecSQL;
          end;
        end;
      end;
    end;
  finally
    frmProductOrderNewList.Free;
    self.Tv2.Controller.EditingController.ShowEdit();
  end;
end;

procedure TfrmYSCRPB_GZ.v2PSPropertiesEditValueChanged(Sender: TObject);
var
  mvalue,FFieldName:String;
begin
  mvalue:=TcxTextEdit(Sender).EditingText;
  if Trim(mvalue)='' then
  begin
    mvalue:='0';
  end;
  FFieldName:=Trim(Tv2.Controller.FocusedColumn.DataBinding.FilterFieldName);
  with CDS_HZ do
  begin
    Edit;
    FieldByName(FFieldName).Value:=Trim(mvalue);
    Post;
  end;
  with ADOQueryCmd do
  begin
    Close;
    sql.Clear;
    sql.Add('UPdate YF_Money_CR ');
    sql.Add(' Set '+FFieldName+'='+Trim(mvalue));
    SQL.Add(',Editer='''+Trim(DName)+'''');
    SQL.Add(',Edittime=getdate() ');
    SQL.Add(' where YFId='''+Trim(CDS_HZ.fieldbyname('YFId').AsString)+'''');
    ExecSQL;
  end;
end;

procedure TfrmYSCRPB_GZ.v2Column2PropertiesEditValueChanged(Sender: TObject);
var
  mvalue,FFieldName:String;
begin
  mvalue:=TcxTextEdit(Sender).EditingText;
  FFieldName:=Trim(Tv2.Controller.FocusedColumn.DataBinding.FilterFieldName);
  with CDS_HZ do
  begin
    Edit;
    FieldByName(FFieldName).Value:=Trim(mvalue);
    Post;
  end;
  with ADOQueryCmd do
  begin
    Close;
    sql.Clear;
    sql.Add('UPdate YF_Money_CR ');
    sql.Add(' Set '+FFieldName+'='''+Trim(mvalue)+'''');
    SQL.Add(',Editer='''+Trim(DName)+'''');
    SQL.Add(',Edittime=getdate() ');
    SQL.Add(' where YFId='''+Trim(CDS_HZ.fieldbyname('YFId').AsString)+'''');
    ExecSQL;
  end;
end;

procedure TfrmYSCRPB_GZ.v2KPMoneyPropertiesEditValueChanged(Sender: TObject);
var
  mvalue,FBBMoney,FKCBB,FFieldName:String;
begin
  mvalue:=TcxTextEdit(Sender).EditingText;
  if Trim(mvalue)='' then
  begin
    mvalue:='0';
  end;
  FFieldName:=Trim(Tv2.Controller.FocusedColumn.DataBinding.FilterFieldName);
  with CDS_HZ do
  begin
    Edit;
    FieldByName(FFieldName).Value:=Trim(mvalue);
    Post;
  end;
  with ADOQueryTemp do
  begin
    Close;
    sql.Clear;
    sql.Add('select isnull(KPMoney,0) KPMoney from YF_Money_CR where YFID='''+cds_hz.fieldbyname('YFID').AsString+'''');
    Open;
  end;
  FKCBB:=ADOQueryTemp.fieldbyname('KPMoney').AsString;
  FBBMoney:=CDS_HZ.fieldbyname('KPMoney').AsString;
  with ADOQueryCmd do
  begin
    Close;
    sql.Clear;
    sql.Add('UPdate YF_Money_CR ');
    sql.Add(' Set '+FFieldName+'='+Trim(mvalue));
    SQL.Add(',Editer='''+Trim(DName)+'''');
    SQL.Add(',Edittime=getdate() ');
    SQL.Add(' where YFId='''+Trim(CDS_HZ.fieldbyname('YFId').AsString)+'''');
    SQL.Add('Update YF_Money_KC Set KCKPMoney=KCKPMoney-'+FKCBB+'+'+FBBMoney);
    sql.Add(' where CRID='''+Trim(CDS_HZ.fieldbyname('CRID').AsString)+'''');
    ExecSQL;
  end;
end;

procedure TfrmYSCRPB_GZ.Button1Click(Sender: TObject);
begin

  IF CDS_HZ.IsEmpty then exit;

  if CDS_HZ.Locate('ssel',true,[])=false then
  begin
    Application.MessageBox('没有选择数据!','提示',0);
    Exit;
  end;
  ADOQueryCmd.Connection.BeginTrans;
  try
    with CDS_HZ do
    begin
      DisableControls;
      First;
      while not eof do
      begin
        If fieldbyname('ssel').AsBoolean then
        begin
          with ADOQueryCmd do
          begin
            close;
            sql.Clear;
            sql.Add('select * from YF_Money_CR ');
            sql.Add('where YFID='+quotedstr(trim(CDS_HZ.fieldbyname('YFID').AsString)));
            open;
            edit;
            Fieldbyname('Price').Value:=strtofloatdef(edit1.Text,0);
            Fieldbyname('Money').Value:=format('%.2f',[Fieldbyname('Qty').AsFloat * strtofloatdef(edit1.Text,0) ]);
            Fieldbyname('BBMoney').Value:=format('%.2f',[Fieldbyname('Qty').AsFloat * strtofloatdef(edit1.Text,0) ]);
            post;
          end;
        end;
        next;
      end;
      First;
      EnableControls;
    end;
    ADOQueryCmd.Connection.CommitTrans;
    InitGrid();
  except
    ADOQueryCmd.Connection.RollbackTrans;
    application.MessageBox('数据保存失败！','提示信息',0);
  end;

end;

procedure TfrmYSCRPB_GZ.CheckBox1Click(Sender: TObject);
begin
  label13.Caption:='0';
  IF CDS_HZ.IsEmpty then exit;
  with CDS_HZ do
  begin
    DisableControls;
    first;
    while not eof do
    begin
      edit;
      fieldbyname('ssel').Value:=checkbox1.Checked;
      Label13.Caption:=floattostr(strtofloat(Label13.Caption)+fieldbyname('Money').AsCurrency);
      post;
      next;
    end;
    First;
    EnableControls;
  end;

end;

procedure TfrmYSCRPB_GZ.cxTabControl1Change(Sender: TObject);
begin
  SetStatus();

  InitGrid();
end;

procedure TfrmYSCRPB_GZ.FormCreate(Sender: TObject);
begin
  cxGrid2.Align:=alclient;
  canshu2:=trim(DParameters2);
  canshu3:=trim(DParameters3);
end;

procedure TfrmYSCRPB_GZ.TchkClick(Sender: TObject);
begin
  IF CDS_HZ.IsEmpty then exit;

  if CDS_HZ.Locate('ssel',true,[])=false then
  begin
    Application.MessageBox('没有选择数据!','提示',0);
    Exit;
  end;
  try
    ADOQueryCmd.Connection.BeginTrans;
    with CDS_HZ do
    begin
      DisableControls;
      First;
      while not eof do
      begin
        IF Fieldbyname('ssel').AsBoolean=true then
        begin
          with ADOQueryCmd do
          begin
            close;
            sql.Clear;
            sql.Add('update YF_Money_CR SET status=''1'' ');
            sql.Add('where YFID ='+quotedstr(trim(CDS_HZ.fieldbyname('YFID').AsString)));
            execsql;
          end;
        end;
        next;
      end;
      First;
      EnableControls;
    end;

    InitGrid();
    ADOQueryCmd.Connection.CommitTrans;
  except
    ADOQueryCmd.Connection.RollbackTrans;
    application.MessageBox('操作失败！','提示信息',0);
  end;
end;

procedure TfrmYSCRPB_GZ.TnochkClick(Sender: TObject);
begin
  IF CDS_HZ.IsEmpty then exit;

  if CDS_HZ.Locate('ssel',true,[])=false then
  begin
    Application.MessageBox('没有选择数据!','提示',0);
    Exit;
  end;
  try
    ADOQueryCmd.Connection.BeginTrans;
    with CDS_HZ do
    begin
      DisableControls;
      First;
      while not eof do
      begin
        IF Fieldbyname('ssel').AsBoolean=true then
        begin
          with ADOQueryCmd do
          begin
            close;
            sql.Clear;
            sql.Add('update YF_Money_CR SET status=''0'' ');
            sql.Add('where YFID ='+quotedstr(trim(CDS_HZ.fieldbyname('YFID').AsString)));
            execsql;
          end;
        end;
        next;
      end;
      First;
      EnableControls;
    end;
    InitGrid();
    ADOQueryCmd.Connection.CommitTrans;
  except
    ADOQueryCmd.Connection.RollbackTrans;
    application.MessageBox('操作失败！','提示信息',0);
  end;
end;

procedure TfrmYSCRPB_GZ.v2ComTaitouPropertiesButtonClick(Sender: TObject;
  AButtonIndex: Integer);
begin
  try
    frmZDYHelp:=TfrmZDYHelp.Create(Application);
    with frmZDYHelp do
    begin
      flag:='ComTaiTou';
      flagname:='公司抬头';
      if ShowModal=1 then
      begin
        with Self.CDS_HZ do
        begin
          Edit;
          FieldByName('ComTaiTou').Value:=Trim(ClientDataSet1.fieldbyname('ZdyName').AsString);
        end;
        with ADOQueryCmd do
        begin
          Close;
          sql.Clear;
          sql.Add('UPdate YF_Money_CR ');
          sql.Add(' Set ComTaiTou='''+Trim(ClientDataSet1.fieldbyname('ZdyName').AsString)+'''');
          SQL.Add(',Editer='''+Trim(DName)+'''');
          SQL.Add(',Edittime=getdate() ');
          SQL.Add(' where YFId='''+Trim(CDS_HZ.fieldbyname('YFId').AsString)+'''');
          ExecSQL;
        end;
      end;
    end;
  finally
    frmZDYHelp.Free;
  end;
end;

procedure TfrmYSCRPB_GZ.TZDSCClick(Sender: TObject);
var i:integer;
begin
  frmFKCR:=TfrmFKCR.create(self) ;
  with frmFKCR do
  begin
    TSsel.visible:=true;
    TOOLButton3.Visible:=false;
    TBDel.Visible:=false;
    tchk.Visible:=false;
    TNochk.Visible:=false;
    for i:=0 to tv2.ColumnCount-1 do
    begin
      IF uppercase(tv2.Columns[i].DataBinding.FieldName)<>'SSEL' then
      tv2.Columns[i].Options.Focusing:=false;
    end;
    if showmodal=1 then
    begin
      with CDS_HZ do
      begin
        first;
        while not eof do
        begin
          if fieldbyname('Ssel').AsBoolean=true then
          begin
            with self.CDS_HZ do
            begin
              append;
              fieldbyname('CRTime').Value:=Now;
              fieldbyname('FactoryName').Value:=trim(frmFKCR.CDS_HZ.fieldbyname('FactoryName').AsString);
              fieldbyname('YFName').Value:=trim(frmFKCR.CDS_HZ.fieldbyname('YFName').AsString);
              fieldbyname('BZType').Value:='￥';
              fieldbyname('Money').Value:=frmFKCR.CDS_HZ.fieldbyname('Money').AsFloat;
              fieldbyname('filler').Value:=trim(DName);
              fieldbyname('HuiLv').Value:=1;
              fieldbyname('SLV').Value:=1;
              fieldbyname('FeeType').Value:='虚拟费用';
              post;
            end;
            self.SaveData();
          end;
          next;
        end;
      end;
    end;
    free;
  end;
end;

procedure TfrmYSCRPB_GZ.VBZPropertiesButtonClick(Sender: TObject;
  AButtonIndex: Integer);
begin
  try
    frmZDYHelp:=TfrmZDYHelp.Create(Application);
    with frmZDYHelp do
    begin
      flag:='BZType';
      flagname:='币种';
      if ShowModal=1 then
      begin
        Self.CDS_HZ.Edit;
        Self.CDS_HZ.FieldByName('BZType').Value:=Trim(ClientDataSet1.fieldbyname('ZDYName').AsString);
        with ADOQueryCmd do
        begin
          Close;
          sql.Clear;
          sql.Add('UPdate YF_Money_CR ');
          sql.Add(' Set BZType='''+Trim(ClientDataSet1.fieldbyname('ZdyName').AsString)+'''');
          SQL.Add(',Editer='''+Trim(DName)+'''');
          SQL.Add(',Edittime=getdate() ');
          SQL.Add(' where YFId='''+Trim(CDS_HZ.fieldbyname('YFId').AsString)+'''');
          ExecSQL;
        end;
      end;
    end;
  finally
    frmZDYHelp.Free;
  end;
end;

procedure TfrmYSCRPB_GZ.v2Column4PropertiesButtonClick(Sender: TObject;
  AButtonIndex: Integer);
begin
  try
    frmZDYHelp:=TfrmZDYHelp.Create(Application);
    with frmZDYHelp do
    begin
      flag:='MP_Spec';
      flagname:='规格';
      if ShowModal=1 then
      begin
        Self.CDS_HZ.Edit;
        Self.CDS_HZ.FieldByName('P_Spec').Value:=Trim(ClientDataSet1.fieldbyname('ZDYName').AsString);
        with ADOQueryCmd do
        begin
          Close;
          sql.Clear;
          sql.Add('UPdate YF_Money_CR ');
          sql.Add(' Set P_Spec='''+Trim(ClientDataSet1.fieldbyname('ZdyName').AsString)+'''');
          SQL.Add(',Editer='''+Trim(DName)+'''');
          SQL.Add(',Edittime=getdate() ');
          SQL.Add(' where YFId='''+Trim(CDS_HZ.fieldbyname('YFId').AsString)+'''');
          ExecSQL;
        end;
      end;
    end;
  finally
    frmZDYHelp.Free;
  end;
end;

procedure TfrmYSCRPB_GZ.v2Column5PropertiesChange(Sender: TObject);
begin
  HJ(CDS_HZ,Label13,CDS_HZ.fieldbyname('Money').AsCurrency);
end;

procedure TfrmYSCRPB_GZ.v2ConNoHZPropertiesButtonClick(Sender: TObject;
  AButtonIndex: Integer);
begin
  frmJYorderConCX:=TfrmJYorderConCX.create(self);
  with frmJYorderConCX do
  begin
    formid:='1';
    if showmodal=1 then
    begin
      Self.CDS_HZ.Edit;
      Self.CDS_HZ.FieldByName('ConNo').Value:=Trim(Order_Main.fieldbyname('ConNo').AsString);
      Self.CDS_HZ.FieldByName('Conid').Value:=Trim(Order_Main.fieldbyname('subid').AsString);
      with ADOQueryCmd do
      begin
        Close;
        sql.Clear;
        sql.Add('UPdate YF_Money_CR ');
        sql.Add(' Set Conid='''+Trim(Order_Main.fieldbyname('subid').AsString)+'''');
        sql.add(',ConNO='''+trim(Order_Main.fieldbyname('ConNO').AsString)+'''');
        SQL.Add(',Editer='''+Trim(DName)+'''');
        SQL.Add(',Edittime=getdate() ');
        SQL.Add(' where YFId='''+Trim(CDS_HZ.fieldbyname('YFId').AsString)+'''');
        ExecSQL;
      end;
    end;
    free;
  end;
end;

procedure TfrmYSCRPB_GZ.v2GYSNamePropertiesButtonClick(Sender: TObject;
  AButtonIndex: Integer);
begin
  try
    frmZdyAttachGYS:=TfrmZdyAttachGYS.Create(Application);
    with frmZdyAttachGYS do
    begin
      if ShowModal=1 then
      begin
        with Self.CDS_HZ do
        begin
          edit;
          FieldByName('GYSname').Value:=Trim(frmZdyAttachGYS.CDS_HZ.fieldbyname('ZdyName').AsString);
        end;
        with ADOQueryCmd do
        begin
          Close;
          sql.Clear;
          sql.Add('UPdate YF_Money_CR ');
          sql.Add(' Set GYSName='''+trim(frmZdyAttachGYS.CDS_HZ.fieldbyname('ZdyName').AsString)+'''');
          SQL.Add(' where YFId='''+Trim(SELF.CDS_HZ.fieldbyname('YFId').AsString)+'''');
          ExecSQL;
        end;
      end;
    end;
  finally
    frmZdyAttachGYS.Free;
  end;
end;

procedure TfrmYSCRPB_GZ.v2Column6PropertiesButtonClick(Sender: TObject;
  AButtonIndex: Integer);
begin
  try
    frmZdyAttachGYS:=TfrmZdyAttachGYS.Create(Application);
    with frmZdyAttachGYS do
    begin
      if ShowModal=1 then
      begin
        with Self.CDS_HZ do
        begin
          edit;
          FieldByName('FactoryName').Value:=Trim(frmZdyAttachGYS.CDS_HZ.fieldbyname('ZdyName').AsString);
        end;
        with ADOQueryCmd do
        begin
          Close;
          sql.Clear;
          sql.Add('UPdate YF_Money_CR ');
          sql.Add(' Set FactoryName='''+Trim(frmZdyAttachGYS.CDS_HZ.fieldbyname('ZdyName').AsString)+'''');
          SQL.Add(' where YFId='''+Trim(SELF.CDS_HZ.fieldbyname('YFId').AsString)+'''');
          ExecSQL;
        end;
      end;
    end;
  finally
    frmZdyAttachGYS.Free;
  end;
end;

procedure TfrmYSCRPB_GZ.DeptKeyPress(Sender: TObject; var Key: Char);
begin
  if key=#13 then
  begin
    with ADOQueryMain do
    begin
      Filtered:=False;
      Close;
      SQL.Clear;
      sql.Add('select SCOrderNO=(select Top 1 JM.ConNo from Cloth_Main JM where JM.Mainid=A.Mainid),');
      sql.add('RMBMoney=(case when (A.BZType<>''$'') and (A.BZType<>''USD'') then Money else 0 end)');
      sql.add(',USDMoney=(case when (A.BZType<>''￥'') and (A.BZType<>''RMB'') then Money else 0 end)');
      sql.add(',isnull((select JM.PRTColor from JYOrder_Sub JM inner join CK_SXPB_CR F on JM.Subid=F.ORDSubIdRK where F.SPID=A.YFTypeId),'''') PRTColor,');
      sql.add('A.*');
      sql.Add(' from YF_Money_CR A');
      sql.Add(' where A.Dept like '''+'%'+trim(Dept.Text)+'%'+''' and A.CRType=''应付款登记''  ');
      //IF cxTabControl1.TabIndex<3 then
      //sql.Add(' and isnull(A.status,''0'')='''+inttostr(cxTabControl1.TabIndex)+'''');
      sql.add(' and isnull(FeeType,'''')=''虚拟费用''');
      Open;
    end;
    SCreateCDS20(ADOQueryMain,CDS_HZ);
    SInitCDSData20(ADOQueryMain,CDS_HZ);
    Label13.Caption:='0';
  end;
end;

procedure TfrmYSCRPB_GZ.GangWeiKeyPress(Sender: TObject; var Key: Char);
begin
  if key=#13 then
  begin
    with ADOQueryMain do
    begin
      Filtered:=False;
      Close;
      SQL.Clear;
      sql.Add('select SCOrderNO=(select Top 1 JM.ConNo from Cloth_Main JM where JM.Mainid=A.Mainid),');
      sql.add('RMBMoney=(case when (A.BZType<>''$'') and (A.BZType<>''USD'') then Money else 0 end)');
      sql.add(',USDMoney=(case when (A.BZType<>''￥'') and (A.BZType<>''RMB'') then Money else 0 end)');
      sql.add(',isnull((select JM.PRTColor from JYOrder_Sub JM inner join CK_SXPB_CR F on JM.Subid=F.ORDSubIdRK where F.SPID=A.YFTypeId),'''') PRTColor,');
      sql.add('A.*');
      sql.Add(' from YF_Money_CR A');
      sql.Add(' where A.GangWei like '''+'%'+trim(GangWei.Text)+'%'+''' and A.CRType=''应付款登记''  ');
      //IF cxTabControl1.TabIndex<3 then
      //sql.Add(' and isnull(A.status,''0'')='''+inttostr(cxTabControl1.TabIndex)+'''');
      sql.add(' and isnull(FeeType,'''')=''虚拟费用''');
      Open;
    end;
    SCreateCDS20(ADOQueryMain,CDS_HZ);
    SInitCDSData20(ADOQueryMain,CDS_HZ);
    Label13.Caption:='0';
  end;
end;

procedure TfrmYSCRPB_GZ.v2GWMoneyPropertiesEditValueChanged(
  Sender: TObject);
var
  mvalue,FFieldName:String;
begin

  mvalue:=TcxTextEdit(Sender).EditingText;
  if mvalue='' then
  begin
    mvalue:='0';
  end;
  FFieldName:=Trim(Tv2.Controller.FocusedColumn.DataBinding.FilterFieldName);
  with CDS_HZ do
  begin
    Edit;
    FieldByName(FFieldName).Value:=Trim(mvalue);
    fieldbyname('Money').AsFloat:=fieldbyname('GWMoney').AsFloat+fieldbyname('JXMoney').AsFloat
                                  +fieldbyname('BTMoney').AsFloat+fieldbyname('JBMoney').AsFloat
                                  -fieldbyname('KouKuan').AsFloat;
    Post;
  end;
  with ADOQueryCmd do
  begin
    Close;
    sql.Clear;
    sql.Add('UPdate YF_Money_CR ');
    if Trim(mvalue)<>'' then
    begin
      sql.Add(' Set '+FFieldName+'='''+Trim(mvalue)+'''');
    end else
    begin
      sql.Add(' Set '+FFieldName+'=NULL');
    end;
    sql.add(',Money='''+trim(CDS_HZ.fieldbyname('Money').AsString)+'''');
    SQL.Add(',Editer='''+Trim(DName)+'''');
    SQL.Add(',Edittime=getdate() ');
    SQL.Add(' where YFId='''+Trim(CDS_HZ.fieldbyname('YFId').AsString)+'''');
    ExecSQL;
  end;
end;

procedure TfrmYSCRPB_GZ.v2GZNamePropertiesButtonClick(Sender: TObject;
  AButtonIndex: Integer);
begin
  try
    frmZDYHelp:=TfrmZDYHelp.Create(Application);
    with frmZDYHelp do
    begin
      flag:='GZName';
      flagname:='姓名';
      if ShowModal=1 then
      begin
        with ADOQueryCmd do
        begin
          Close;
          sql.Clear;
          sql.Add('select Top 1 * from YF_Money_CR ');
          sql.Add(' where GZName='''+Trim(ClientDataSet1.fieldbyname('ZdyName').AsString)+'''');
          sql.add(' order by filltime desc');
          open;
        end;
        Self.CDS_HZ.Edit;
        Self.CDS_HZ.FieldByName('GZName').Value:=Trim(ClientDataSet1.fieldbyname('ZDYName').AsString);
        Self.CDS_HZ.FieldByName('GangWei').Value:=Trim(ADOQueryCmd.fieldbyname('GangWei').AsString);
        Self.CDS_HZ.FieldByName('Dept').Value:=Trim(ADOQueryCmd.fieldbyname('Dept').AsString);
        //Self.CDS_HZ.FieldByName('FactoryName').Value:=Trim(ADOQueryCmd.fieldbyname('FactoryName').AsString);
        Self.CDS_HZ.FieldByName('GWMoney').Value:=ADOQueryCmd.fieldbyname('GWMoney').AsFloat;
        with ADOQueryCmd do
        begin
          Close;
          sql.Clear;
          sql.Add('UPdate YF_Money_CR ');
          sql.Add(' Set GZName='''+Trim(ClientDataSet1.fieldbyname('ZdyName').AsString)+'''');
          sql.add(',GangWei='''+trim(Self.CDS_HZ.fieldbyname('GangWei').AsString)+'''');
          sql.add(',Dept='''+trim(Self.CDS_HZ.fieldbyname('Dept').AsString)+'''');
          //sql.add(',FactoryName='''+trim(Self.CDS_HZ.fieldbyname('FactoryName').AsString)+'''');
          if Self.CDS_HZ.fieldbyname('GWMoney').AsFloat<>0 then
          sql.add(',GWMoney='''+trim(Self.CDS_HZ.fieldbyname('GWMoney').AsString)+'''');
          SQL.Add(',Editer='''+Trim(DName)+'''');
          SQL.Add(',Edittime=getdate() ');
          SQL.Add(' where YFId='''+Trim(CDS_HZ.fieldbyname('YFId').AsString)+'''');
          ExecSQL;
        end;
      end;
    end;
  finally
    frmZDYHelp.Free;
  end;
end;

procedure TfrmYSCRPB_GZ.v2GangWeiPropertiesButtonClick(Sender: TObject;
  AButtonIndex: Integer);
begin
  try
    frmZDYHelp:=TfrmZDYHelp.Create(Application);
    with frmZDYHelp do
    begin
      flag:='GangWei';
      flagname:='岗位';
      if ShowModal=1 then
      begin
        with Self.CDS_HZ do
        begin
          Edit;
          FieldByName('GangWei').Value:=Trim(ClientDataSet1.fieldbyname('ZdyName').AsString);
        end;
        with ADOQueryCmd do
        begin
          Close;
          sql.Clear;
          sql.Add('UPdate YF_Money_CR ');
          sql.Add(' Set GangWei='''+Trim(ClientDataSet1.fieldbyname('ZdyName').AsString)+'''');
          SQL.Add(',Editer='''+Trim(DName)+'''');
          SQL.Add(',Edittime=getdate() ');
          SQL.Add(' where YFId='''+Trim(CDS_HZ.fieldbyname('YFId').AsString)+'''');
          ExecSQL;
        end;
      end;
    end;
  finally
    frmZDYHelp.Free;
  end;
end;

procedure TfrmYSCRPB_GZ.v2DeptPropertiesButtonClick(Sender: TObject;
  AButtonIndex: Integer);
begin
  try
    frmZDYHelp:=TfrmZDYHelp.Create(Application);
    with frmZDYHelp do
    begin
      flag:='Dept';
      flagname:='部门';
      if ShowModal=1 then
      begin
        with Self.CDS_HZ do
        begin
          Edit;
          FieldByName('Dept').Value:=Trim(ClientDataSet1.fieldbyname('ZdyName').AsString);
        end;
        with ADOQueryCmd do
        begin
          Close;
          sql.Clear;
          sql.Add('UPdate YF_Money_CR ');
          sql.Add(' Set Dept='''+Trim(ClientDataSet1.fieldbyname('ZdyName').AsString)+'''');
          SQL.Add(',Editer='''+Trim(DName)+'''');
          SQL.Add(',Edittime=getdate() ');
          SQL.Add(' where YFId='''+Trim(CDS_HZ.fieldbyname('YFId').AsString)+'''');
          ExecSQL;
        end;
      end;
    end;
  finally
    frmZDYHelp.Free;
  end;
end;

procedure TfrmYSCRPB_GZ.TPrintClick(Sender: TObject);
var fPrintFile:string;
begin
  if CDS_HZ.IsEmpty then exit;
  fPrintFile:= ExtractFilePath(Application.ExeName) + 'Report\工资年度汇总表.rmf';
  with ADOQueryCmd do
  begin
    close;
    sql.Clear;
    sql.Add('select year(A.CRTime) NFYear,A.GZName,Sum(Money) ZMoney');
    sql.add(',YIMoney=(select Sum(B.Money) from YF_Money_CR B where year(B.CRTime)=year(A.CRTime) and B.GZName=A.GZName ');
    sql.add('and B.CRType=''应付款登记'' and isnull(B.YFName,'''')=''工资'' and isnull(B.ConNo,'''')='''' and isnull(B.OrderNo,'''')='''' and Month(B.CRTime)=''01'')');
    sql.add(',ERMoney=(select Sum(B.Money) from YF_Money_CR B where year(B.CRTime)=year(A.CRTime) and B.GZName=A.GZName ');
    sql.add('and B.CRType=''应付款登记'' and isnull(B.YFName,'''')=''工资'' and isnull(B.ConNo,'''')='''' and isnull(B.OrderNo,'''')='''' and Month(B.CRTime)=''02'')');
    sql.add(',SANMoney=(select Sum(B.Money) from YF_Money_CR B where year(B.CRTime)=year(A.CRTime) and B.GZName=A.GZName ');
    sql.add('and B.CRType=''应付款登记'' and isnull(B.YFName,'''')=''工资'' and isnull(B.ConNo,'''')='''' and isnull(B.OrderNo,'''')='''' and Month(B.CRTime)=''03'')');
    sql.add(',SIMoney=(select Sum(B.Money) from YF_Money_CR B where year(B.CRTime)=year(A.CRTime) and B.GZName=A.GZName ');
    sql.add('and B.CRType=''应付款登记'' and isnull(B.YFName,'''')=''工资'' and isnull(B.ConNo,'''')='''' and isnull(B.OrderNo,'''')='''' and Month(B.CRTime)=''04'')');
    sql.add(',WUMoney=(select Sum(B.Money) from YF_Money_CR B where year(B.CRTime)=year(A.CRTime) and B.GZName=A.GZName ');
    sql.add('and B.CRType=''应付款登记'' and isnull(B.YFName,'''')=''工资'' and isnull(B.ConNo,'''')='''' and isnull(B.OrderNo,'''')='''' and Month(B.CRTime)=''05'')');
    sql.add(',LIUMoney=(select Sum(B.Money) from YF_Money_CR B where year(B.CRTime)=year(A.CRTime) and B.GZName=A.GZName ');
    sql.add('and B.CRType=''应付款登记'' and isnull(B.YFName,'''')=''工资'' and isnull(B.ConNo,'''')='''' and isnull(B.OrderNo,'''')='''' and Month(B.CRTime)=''06'')');
    sql.add(',QIMoney=(select Sum(B.Money) from YF_Money_CR B where year(B.CRTime)=year(A.CRTime) and B.GZName=A.GZName ');
    sql.add('and B.CRType=''应付款登记'' and isnull(B.YFName,'''')=''工资'' and isnull(B.ConNo,'''')='''' and isnull(B.OrderNo,'''')='''' and Month(B.CRTime)=''07'')');
    sql.add(',BAMoney=(select Sum(B.Money) from YF_Money_CR B where year(B.CRTime)=year(A.CRTime) and B.GZName=A.GZName ');
    sql.add('and B.CRType=''应付款登记'' and isnull(B.YFName,'''')=''工资'' and isnull(B.ConNo,'''')='''' and isnull(B.OrderNo,'''')='''' and Month(B.CRTime)=''08'')');
    sql.add(',JIUMoney=(select Sum(B.Money) from YF_Money_CR B where year(B.CRTime)=year(A.CRTime) and B.GZName=A.GZName ');
    sql.add('and B.CRType=''应付款登记'' and isnull(B.YFName,'''')=''工资'' and isnull(B.ConNo,'''')='''' and isnull(B.OrderNo,'''')='''' and Month(B.CRTime)=''09'')');
    sql.add(',SHIMoney=(select Sum(B.Money) from YF_Money_CR B where year(B.CRTime)=year(A.CRTime) and B.GZName=A.GZName ');
    sql.add('and B.CRType=''应付款登记'' and isnull(B.YFName,'''')=''工资'' and isnull(B.ConNo,'''')='''' and isnull(B.OrderNo,'''')='''' and Month(B.CRTime)=''10'')');
    sql.add(',SHIYIMoney=(select Sum(B.Money) from YF_Money_CR B where year(B.CRTime)=year(A.CRTime) and B.GZName=A.GZName ');
    sql.add('and B.CRType=''应付款登记'' and isnull(B.YFName,'''')=''工资'' and isnull(B.ConNo,'''')='''' and isnull(B.OrderNo,'''')='''' and Month(B.CRTime)=''11'')');
    sql.add(',SHIERMoney=(select Sum(B.Money) from YF_Money_CR B where year(B.CRTime)=year(A.CRTime) and B.GZName=A.GZName ');
    sql.add('and B.CRType=''应付款登记'' and isnull(B.YFName,'''')=''工资'' and isnull(B.ConNo,'''')='''' and isnull(B.OrderNo,'''')='''' and Month(B.CRTime)=''12'')');
    sql.Add(' from YF_Money_CR A');
    sql.Add(' where year(A.CRTime)>='''+trim(formatdatetime('yyyy',begdate.DateTime))+''' ');
    sql.Add(' and year(A.CRTime)<='''+trim(formatdatetime('yyyy',enddate.DateTime))+''' ');
    if ComTaitou.Text<>'' then
    sql.add(' and A.ComTaitou like '''+'%'+trim(ComTaitou.Text)+'%'+'''');
    if Dept.Text<>'' then
    sql.add(' and A.Dept like '''+'%'+trim(Dept.Text)+'%'+'''');
    if GangWei.Text<>'' then
    sql.add(' and A.GangWei like '''+'%'+trim(GangWei.Text)+'%'+'''');
    if FactoryName.Text<>'' then
    sql.add(' and A.FactoryName like '''+'%'+trim(FactoryName.Text)+'%'+'''');
    sql.add(' and A.YFName=''工资''');
    sql.Add(' and A.CRType=''应付款登记''  ');
    sql.add(' and isnull(A.ConNo,'''')='''' and isnull(A.OrderNo,'''')=''''');
    sql.add(' group by year(A.CRTime),A.GZName');
    open;
  end;
  SCreateCDS20(ADOQueryCmd,Order_Print);
  SInitCDSData20(ADOQueryCmd,Order_Print);
  if FileExists(fPrintFile) then
  begin
    if (GangWei.Text<>'') or (Dept.Text<>'') then
    RMVariables['FDept']:=trim(CDS_HZ.fieldbyname('Dept').AsString)
    else
    if (FactoryName.Text<>'') or (ComTaitou.Text<>'') then
    RMVariables['FDept']:=trim(CDS_HZ.fieldbyname('ComTaitou').AsString)
    else
    RMVariables['FDept']:='';
    RM1.LoadFromFile(fPrintFile);
    RM1.ShowReport;
  end else
  begin
    Application.MessageBox(PChar('没有找'+ExtractFilePath(Application.ExeName)+'Report\费用年度汇总表.rmf'),'提示',0);
  end;
end;

end.
